package Msm::Admin;

use strict;
use Time::Local;
use Msm::IO;
use Msm::Replace;
use Msm::CellPhone;
use Msm::Config;
#use Time::HiRes qw/gettimeofday tv_interval/;
use base qw(Msm::BaseRequest);

sub new{
	my $self=shift;
	my $cgi=shift;
	my $config=shift;
	my $io=shift;
	my $db=shift;
	my $hash={};
	bless $hash,$self;
	$hash->{PrintCookie}=0;
	$hash->{CGI}=$cgi;
	$hash->{DB}=$db;
	$hash->{CellPhone}=new Msm::CellPhone();
	$hash->{DATA}=undef;
	$hash->{HEADER}='Content-type: text/html';
	$hash->{Err}=();
	$hash->{Config}=$config;
	$hash->{IO}=$io;
	$hash->{AuthFileFlg}=0;
	$hash->{UserConfig}=undef;

	eval('use Msm::Admin::'.$config->getConfigData('','savename').';');
	eval('$hash->{DBCLASS}=new Msm::Admin::'.$config->getConfigData('','savename').'($hash);');


	my %cook=$hash->{CGI}->cookie(-name=>'MySketch');
	foreach(keys %cook){
		$hash->{Cookie}->{$_}=$cook{$_};
	}

	$ENV{'TZ'}='JST-9';

	return $hash;
}

sub getDB(){
	my $self=shift;
	return $self->{DB};
}

sub getAuth{
	my $self=shift;
	my $t=shift;
	return $self->SUPER::getAuth($t,'./ini/adminid');
}

sub getUsers{
	my $self=shift;
	my @user=();
	push @user,{adminuser=>$self->getConfigData('','adminuser')
	,adminpass=>$self->getConfigData('','adminpass')
	};
	return \@user;
}

sub checkAuth{
	my $self=shift;

	return $self->SUPER::checkAuth('./ini/adminid',$self->getUsers());
}

sub load_template{
	my $self=shift;
	my $t=shift;
	my $mode=shift;
	my $html='';

	$html=$self->SUPER::load_template('./admintemplate/'.$t,$mode);

	return $html;
}


sub execute{
	my $self=shift;
	if($self->getCGI()->param('mode') eq 'usermake'){
		my $id=$self->createUser();
		$self->getCGI->param(-name=>'userid',-value=>$id);
		$self->setUserData();
	}
	elsif($self->getCGI()->param('mode') eq 'blogmake'){
		$self->createBlog();
	}
	elsif($self->getCGI()->param('mode') eq 'blogsetting'){
		$self->viewBlog();
	}
	elsif($self->getCGI()->param('mode') eq 'blogsettinginput'){
		$self->usersBlog();
	}
	elsif($self->getCGI()->param('mode') eq 'blogsettinginputok'){
		$self->setUsersBlog();
	}
	elsif($self->getCGI()->param('mode') eq 'useredit'){

		$self->viewUser();
	}
	elsif($self->getCGI()->param('mode') eq 'usereditinput'){
		$self->setUserData();
	}
	elsif($self->getCGI()->param('mode') eq 'usereditinputok'){
		$self->createUser($self->getCGI->param('userid'));
	}
	elsif($self->getCGI()->param('mode') eq 'blogs'){
		$self->setBlogs();
	}
	elsif($self->getCGI()->param('mode') eq 'templates'){
		$self->setTemplates();
	}
	elsif($self->getCGI()->param('mode') eq 'templates_run'){
		$self->setTemplatesRun();
	}
	return;
}

sub createUser{
	my $self=shift;
	my $id=shift;
	my $cgi=$self->getCGI();
	if(!($cgi->param('id')) || !($cgi->param('pass')) || !($cgi->param('nickname'))){
		$self->setErr('͂܂B');
		return;
	}
	if($cgi->param('id')=~/[^a-zA-Z0-9]/ || $cgi->param('pass')=~/[^a-zA-Z0-9]/){
		$self->setErr('ID,PASS͉płB');
		return;
	}

	if(!($id)){
		$id=$self->getConfigData('','maxuserid');
		$id++;
	}
	my $config=new Msm::Config('user_'.$id,,$self->getConfig(),$self->getDB());
	my $unconfig=new Msm::Config('username_'.$cgi->param('id'),$self->getConfig(),$self->getDB());
	unless($self->getCGI->param('userid')){
		unless($unconfig->getNew){
			$self->setErr('w肳ꂽ[U݂܂B');
			return;
		}
	}

	$config->setConfigDataOverWrite('default','user','[UID',$cgi->param('id'));
	$config->setConfigDataOverWrite('default','pass','pX[h',$cgi->param('pass'));
	$config->setConfigDataOverWrite('default','nickname','jbNl[',$cgi->param('nickname'));
	$config->rewriteConfig($config->getAllConfigDataMap(),$self->getConfigData('','fileperm'));
	$self->getConfig()->setConfigDataOverWrite('default','maxuserid',$self->getConfig->getConfigInfo('default','maxuserid'),$id);
	$self->getConfig()->rewriteConfig($self->getConfig()->getAllConfigDataMap(),$self->getConfigData('','fileperm'));

	$unconfig=new Msm::Config('username_'.$cgi->param('id'),$self->getConfig(),$self->getDB());
	$unconfig->setConfigDataOverWrite('default','userid',$self->getConfig->getConfigInfo('default','userid'),$id);
	$unconfig->rewriteConfig($unconfig->getAllConfigDataMap(),$self->getConfigData('','fileperm'));

	return $id;
}


sub usersBlog{
	my $self=shift;
	my $cgi=$self->getCGI();

	my $blogid=$cgi->param('blogid');

	my $config=new Msm::Config('bloguser_'.$blogid,$self->getConfig(),$self->getDB());
	my $val=undef;
	if($config->getConfigData('','blogusers')){
		foreach my $data (@{$config->getConfigData('','blogusers')}){
			$val.="$data,";
		}
		$val=~s/,$//;
	}

	$self->setData('usersBlog','users',$val);
}

sub setUsersBlog{
	my $self=shift;
	my $cgi=$self->getCGI();

	my $users=$cgi->param('users');
	my $blogid=$cgi->param('blogid');

	if(!($cgi->param('users')) || !($cgi->param('blogid'))){
		$self->setErr('͂܂B');
		return;
	}
	if($cgi->param('users')=~/[^0-9,]/ || $cgi->param('users')=~/^,/ || $cgi->param('users')=~/,$/){
		$self->setErr(',͂ł܂B܂,͐擪͍ŌɂĂ͂܂B');
		return;
	}

	my @user=split(/,/,$users);

	my $config=new Msm::Config('bloguser_'.$blogid,$self->getConfig(),$self->getDB());

	$config->setConfigDataOverWrite('default','blogusers',$self->getConfig->getConfigInfo('default','blogusers'),\@user);
	$config->rewriteConfig($config->getAllConfigDataMap(),$self->getConfigData('','fileperm'));

	foreach my $uid(@user){
		my $ubconfig=new Msm::Config('userblog_'.$uid,$self->getConfig(),$self->getDB());
		my $blogs=$ubconfig->getConfigData('','usersblog');
		if(!($blogs)){
			$blogs=[];
		}
		my $flg=0;
		foreach my $bid(@{$blogs}){
			if($bid eq $blogid){
				$flg=1;
				last;
			}
		}
		if($flg == 0){
			push @{$blogs},$blogid;
			$ubconfig->setConfigDataOverWrite('default','usersblog',$self->getConfig->getConfigInfo('default','usersblog'),\@{$blogs});
			$ubconfig->rewriteConfig($ubconfig->getAllConfigDataMap(),$self->getConfigData('','fileperm'));
		}

	}
}

sub viewBlog{
	my $self=shift;
	$self->{DBCLASS}->viewBlog();
}

sub viewUser{
	my $self=shift;
	$self->{DBCLASS}->viewUser();
}

sub setBlogs{
	my $self=shift;
	$self->{DBCLASS}->setBlogs();
}

sub getBlogsID{
	my $self=shift;
	return $self->{DBCLASS}->getBlogsID();
}

sub setUserData{
	my $self=shift;
	my $cgi=$self->getCGI();

	my $userid=$cgi->param('userid');
	my $config=new Msm::Config('user_'.$userid,$self->getConfig(),$self->getDB());

	$self->setData('UserEdit','id',$config->getConfigData('','user'));
	$self->setData('UserEdit','pass',$config->getConfigData('','pass'));
	$self->setData('UserEdit','nickname',$config->getConfigData('','nickname'));
}

sub setTemplates{
	my $self=shift;
	my $cgi=$self->getCGI();
	my $inittmp='./inittmp';
	my @files=@{$self->getfiles($inittmp,[])};
	my $val='';
	foreach my $ent(sort @files){
		$ent=~s/^$inittmp\///;
		$val.=qq|<input type="checkbox" name="templates" value="$ent">$ent<br>|;
	}
	$self->setData('Templates','templatehtml',$val);
}

sub setTemplatesRun{
	my $self=shift;
	my $cgi=$self->getCGI();
	my $inittmp='./inittmp/';
	my @temps=$cgi->param('templates');
	my @id=$self->getBlogsID();
	my $io=new Msm::IO($self->getConfigData('','fileperm'),$self->getConfigData('','dirperm'));
	my $datahash={};
	foreach my $data(@temps){
		$datahash->{$data}=$io->readFile($inittmp.$data);
	}
	foreach my $id(@id){
		my $config=undef;
		foreach my $key(keys %{$datahash}){
			if($key=~/^template/){
				$io->writeFile($self->getConfigData('','userdatadir').'/'.$id.'/'.$key,$datahash->{$key});
			}
			elsif($key=~/^css/){
				unless($config){
					$config=new Msm::Config('blog_'.$id,$self->getConfig(),$self->getDB());
				}
				$io->writeFile($config->getConfigData('','staticindexdir').$key,$datahash->{$key});
			}
			elsif($key=~/^files/){
				unless($config){
					$config=new Msm::Config('blog_'.$id,$self->getConfig(),$self->getDB());
				}
				$io->writeFile($config->getConfigData('','staticindexdir').$key,$datahash->{$key},1);
			}
		}
	}
}

sub createBlog{
	my $self=shift;
	my $cgi=$self->getCGI();
	if(!($cgi->param('path')) || !($cgi->param('name'))){
		$self->setErr('͂܂B');
		return;
	}
	if($cgi->param('path')=~/[^a-zA-Z0-9]/){
		$self->setErr('uOpX͉płB');
		return;
	}
	if(-e $self->getConfigData('','staticindexdir').$cgi->param('path')){
		$self->setErr('̃pXɂ̓uOłɑ݂܂B');
		return;
	}

	my $id=$self->getConfigData('','maxblogid');
	$id++;
	my $config=new Msm::Config('blog_'.$id,$self->getConfig(),$self->getDB());

	$config->setConfigDataOverWrite('default','staticindexurl','gbvy[WURL<br>ÓIo̓[hindex.html̏ꏊBȊOms.cgȉꏊ',$self->getConfigData('','staticindexurl').$cgi->param('path').'/');
	$config->setConfigDataOverWrite('default','staticindexdir','gbvy[WURL̏ꏊms.cgi݂Έʒu',$self->getConfigData('','staticindexdir').$cgi->param('path').'/');
	$config->setConfigDataOverWrite('default','msname','uO^Cg',$cgi->param('name'));
	$config->setConfigDataOverWrite('default','staticmode','ÓIo̓[h<br>0:off<br>1:on<br>onɂƃy[W\ɑȂ܂Bev[gύXɂ͍č\zKvłB','1');
	$config->setConfigDataOverWrite('default','staticmode_index','ÓIo̓[hڍאݒ(gbvy[WÓI)<br>0:off<br>1:on','1');
	$config->setConfigDataOverWrite('default','staticmode_category','ÓIo̓[hڍאݒ(JeSy[WÓI)<br>0:off<br>1:on','1');
	$config->setConfigDataOverWrite('default','staticmode_month','ÓIo̓[hڍאݒ(y[WÓI)<br>0:off<br>1:on','1');
	$config->setConfigDataOverWrite('default','staticmode_day','ÓIo̓[hڍאݒ(y[WÓI)<br>0:off<br>1:on','0');
	$config->setConfigDataOverWrite('default','staticmode_sketch','ÓIo̓[hڍאݒ(Ly[WÓI)<br>0:off<br>1:on','0');
	$config->setConfigDataOverWrite('default','rsscnt','RSSo͋L','10');
	$config->setConfigDataOverWrite('default','rsslength','RSS','200');
	$config->setConfigDataOverWrite('default','usefileinfo','fileinfo.txtgp邩H<br>0:gpȂ<br>1:gp<br>gpɂƓ͑Ȃ܂BFTPɂL̒ǉł͔fȂȂ܂B<br>gpIFTPŋL̒ǉor폜ꍇ͂Ȃł̂ŋLҏWĂB','1');
	$config->setConfigDataOverWrite('default','timestamp','fileinfo.txtɂ^CX^vǗsH<br>0:sȂ<br>1:s<br>̍ڂfileinfo.txtgpɂȂĂȂƈӖ܂B<br>fileinfo.txtč\zĂ܂ƍ폜L͊Ǘ܂B','1');

	$config->rewriteConfig($config->getAllConfigDataMap(),$self->getConfigData('','fileperm'));


	$self->getConfig()->setConfigDataOverWrite('default','maxblogid',$self->getConfig->getConfigInfo('default','maxblogid'),$id);
	$self->getConfig()->rewriteConfig($self->getConfig()->getAllConfigDataMap(),$self->getConfigData('','fileperm'));


	my $io=new Msm::IO($self->getConfigData('','fileperm'),$self->getConfigData('','dirperm'));

	$io->createDir($config->getConfigData('','staticindexdir').'dummy');
	$io->createDir($config->getConfigData('','staticindexdir').'category/dummy');
	$io->createDir($config->getConfigData('','staticindexdir').'date/dummy');
	$io->createDir($self->getConfigData('','userdatadir').'/'.$id.'/data/dummy');
	$io->createDir($self->getConfigData('','userdatadir').'/'.$id.'/ini/dummy');
	$io->createDir($config->getConfigData('','staticindexdir').'files/dummy');
	$io->createDir($self->getConfigData('','userdatadir')..$id.'/plugdata/dummy');
	$io->createDir($self->getConfigData('','userdatadir')..$id.'/template/dummy');
	$io->createDir($config->getConfigData('','staticindexdir').'css/dummy');


	chmod oct($self->getConfigData('','dirperm')),$config->getConfigData('','staticindexdir');
	chmod oct($self->getConfigData('','dirperm')),$config->getConfigData('','staticindexdir').'category';
	chmod oct($self->getConfigData('','dirperm')),$config->getConfigData('','staticindexdir').'date';
	chmod oct($self->getConfigData('','dirperm')),$self->getConfigData('','userdatadir')..$id.'/data';
	chmod oct($self->getConfigData('','dirperm')),$config->getConfigData('','staticindexdir').'files';
	chmod oct($self->getConfigData('','dirperm')),$self->getConfigData('','userdatadir')..$id.'/plugdata';
	chmod oct($self->getConfigData('','dirperm')),$self->getConfigData('','userdatadir')..$id.'/template';
	chmod oct($self->getConfigData('','dirperm')),$config->getConfigData('','staticindexdir').'css';

	my $dir='./inittmp/css';
	opendir DIR,$dir;
	while(my $entry=readdir DIR){
		if(-f $dir.'/'.$entry){
			my $ret=$io->readFile($dir.'/'.$entry);
			#u
			$ret=~s/\[%\s*Config\.default\.(.+?)\s*%\]/$config->getConfigData('',$1)/ego;
			$io->writeFile($config->getConfigData('','staticindexdir').'css/'.$entry,$ret);
		}
	}
	closedir(DIR);

	$dir='./inittmp/template';
	my @files=@{$self->getfiles($dir,[])};
	foreach my $v(@files){
		my $v_tmp=$v;
		$v_tmp=~s/^$dir//;
		$io->createDir($self->getConfigData('','userdatadir')..$id.'/template'.$v_tmp);
		my $ret=$io->readFile($v);
		$io->writeFile($self->getConfigData('','userdatadir')..$id.'/template'.$v_tmp,$ret);
	}

	$dir='./inittmp/files';
	@files=@{$self->getfiles($dir,[])};
	foreach my $v(@files){
		my $v_tmp=$v;
		$v_tmp=~s/^$dir//;
		my $ret=$io->readFile($v,1);
		$io->writeFile($config->getConfigData('','staticindexdir').'files'.$v_tmp,$ret,1);
	}

	#t@CƂ
	$self->_setDirPerm($config->getConfigData('','staticindexdir').'css');
	$self->_setDirPerm($self->getConfigData('','userdatadir')..$id.'/template');

	return;
}

sub _setDirPerm{
	my $self=shift;
	my $dir=shift;

	opendir DIR,$dir;
	while(my $entry=readdir DIR){
		if(-f $dir.'/'.$entry){
			chmod oct($self->getConfigData('','fileperm')),$dir.'/'.$entry;
		}
	}
	closedir(DIR);
}
sub getfiles{
	my $self=shift;
	my $dir=shift;
	my $list=shift;
	my @dir=();
	opendir DIR,$dir;
	while(my $entry=readdir DIR){

		if($entry =~ /^\./){
			next;
		}
		if(-f $dir.'/'.$entry){
			push @{$list},$dir.'/'.$entry;
			next;
		}

		push @dir,$dir..$entry;
	}
	closedir(DIR);
	foreach (@dir){
		$list=$self->getfiles($_,$list);
	}
	return $list;
}

1;
