package Msm::Backup::File;

use strict;
use Msm::XmlParse;

sub new{
	my $self=shift;
	my $back=shift;
	my $hash={};
	bless $hash,$self;
	$hash->{Backup}=$back;

	return $hash;
}

sub setTimestamp{
	my $self=shift;
	my $MShash=$self->{Backup}->getMS();
	my $ddir=$MShash->getDataDir();

	my @info=();
	if($MShash->getConfig->{FILENAME} eq 'Config'){
		@info=$MShash->getIO->readFileArray('./ini/fileinfo.txt');
	}else{
		@info=$MShash->getIO->readFileArray($MShash->getAdConfigData('userdatadir').'/'.$MShash->getCGI->param('blogid').'/ini/fileinfo.txt');
	}

	foreach my $v(@info){
		chomp $v;
		my ($file,$time)=split(/<>/,$v);
		if($file =~ /^$ddir\/.+\//o){
			if(-e $file){
				utime $time,$time,$file;
			}
		}
	}
	return;
}

sub recoveryData{
	my $self=shift;
	my $xml=shift;
	my $option=shift;
	my $MShash=$self->{Backup}->getMS();
	my $ddir=$MShash->getDataDir();

	#Lf[^Rs[
	my $bddir=$ddir.$self->backupTime();
	my %file=%{$MShash->getSketchFiles()};
	$MShash->getIO->createDir($bddir);
	foreach my $v(keys %file){
		my $data=$MShash->getSketchData($v);
		my $come=$data->{comment};;
		my $title=$data->{title};
		my $time=(stat $v)[9];
		$v=~s/^$ddir//;
		$MShash->getIO->createDir($bddir.$v);
		$MShash->getIO->writeFile($bddir.$v,$title."\n".$come);
		utime $time,$time,($bddir.$v);
	}

	#Rs[fBNgɃRs[ƓԂZbg
	my $dirhash=$MShash->getAllDirs($MShash->getDataDir(),{});
	foreach my $v(sort {$b cmp $a} keys %{$dirhash}){
		my $tmp=$v;
		$tmp=~s/^$ddir//;
		if($tmp !~ /\.\./){
			my $time=(stat $v)[9];
			utime $time,$time,($bddir.$tmp);
		}
	}

	#ɋL폜ƂiftHgj̏
	unless($option){
		#܂S폜ȁH
		foreach my $v(keys %file){
			my $tmp=$v;
			$tmp=~s/^$ddir//;
			if($tmp !~ /\.\./){
				unlink($v);
			}
		}

		foreach my $v(sort {$b cmp $a} keys %{$dirhash}){
			my $tmp=$v;
			$tmp=~s/^$ddir//;
			if($tmp !~ /\.\./){
				rmdir($v);
			}
		}
	}

	my $parse=new Msm::XmlParse($xml,$MShash);
	my $rnode=$parse->getRootNode();
	my @cnode=$rnode->getChildNodes();
	foreach my $file(@cnode){
		my @val=$file->getChildNodes();
		my $name=$val[0]->getValue();
		if($name !~ /\.\./){
			my $time=$val[1]->getValue();
			my $title=$val[2]->getValue();
			my $come=$val[3]->getValue();
			$MShash->getIO->createDir($ddir.$name);
			$MShash->getIO->writeFile($ddir.$name,$file->unescape($title."\n".$come));
			utime $time,$time,($ddir.$name);
		}
	}

	#fBNgɃRs[fBNgƓԂZbg
	foreach my $v(sort {$b cmp $a} keys %{$dirhash}){
		my $tmp=$v;
		$tmp=~s/^$ddir//;
		if($tmp !~ /\.\./ && -e $v){
			my $time=(stat $bddir.$tmp)[9];
			utime $time,$time,($v);
		}
	}
	return;
}

sub recoveryPlugData{
	my $self=shift;
	my $xml=shift;
	my $option=shift;
	my $MShash=$self->{Backup}->getMS();
	my $pdir=$MShash->getPlugDataDir();

	#vOCf[^Rs[
	my $bpdir=$pdir.$self->backupTime();
	my $hash={};
	my $dirs=$MShash->getPlugDirs($MShash->getPlugDataDir(),{});
	foreach(keys %{$dirs}){
		$hash=$MShash->getPlugDirFiles($_,$hash);
	}
	my %file=%{$hash};
	foreach my $v(keys %file){
		my $tmp=$v;
		$tmp =~ s/^$pdir//;
		my $plug=$tmp;
		my $dir='';
		my $file='';
		if($tmp =~ /^\/(.+?)(\/.+)\/(.+)$/){
			$plug=$1;
			$dir=$2;
			$file=$3;
		}elsif($tmp =~ /^\/(.*?)\/(.+)$/){
			$plug=$1;
			$file=$2;
		}
		#print "$plug,$dir,$file<br>";
		my @ret=$MShash->readPlugData($plug,$dir,$file);
		my $come='';
		$come.=$_ foreach (@ret);
		my $time=(stat $v)[9];
		$MShash->getIO->createDir($bpdir.$tmp);
		$MShash->getIO->writeFile($bpdir.$tmp,$come);
		utime $time,$time,($bpdir.$tmp);
	}

	#Rs[fBNgɃRs[ƓԂZbg
	foreach my $v(sort {$b cmp $a} keys %{$dirs}){
		my $tmp=$v;
		$tmp=~s/^$pdir//;
		if($tmp !~ /\.\./){
			my $time=(stat $v)[9];
			utime $time,$time,($bpdir.$tmp);
		}
	}

	#ɃvOCf[^폜ƂiftHgj̏
	unless($option){
		#܂S폜ȁH
		$hash={};
		foreach my $v(sort {$b cmp $a} keys %{$dirs}){
			if($v eq $pdir . '/EazyAnalyzer'){next;}
			$hash=$MShash->getPlugDirFiles($v,{});
			foreach my $v2(keys %{$hash}){
				unlink($v2);
			}
			rmdir($v);
		}
	}

	my $parse=new Msm::XmlParse($xml,$MShash);
	my $rnode=$parse->getRootNode();
	my @cnode=$rnode->getChildNodes();
	foreach my $file(@cnode){
		my @val=$file->getChildNodes();
		my $plug=$val[0]->getValue();
		my $name=$val[1]->getValue();
		if($name !~ /\.\./){
			my $value=$val[2]->getValue();
			$MShash->getIO->createDir($pdir.'/'.$plug.$name);
			$MShash->getIO->writeFile($pdir.'/'.$plug.$name,$file->unescape($value));
		}
	}

	#fBNgɃRs[fBNgƓԂZbg
	foreach my $v(sort {$b cmp $a} keys %{$dirs}){
		my $tmp=$v;
		$tmp=~s/^$pdir//;
		if($tmp !~ /\.\./ && -e $v){
			my $time=(stat $bpdir.$tmp)[9];
			utime $time,$time,($v);
		}
	}
	return;
}

sub backupTime{
	my($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdst)=localtime();
	$year+=1900;
	$mon++;
	return sprintf('_bak_%04d-%02d-%02dT%02d_%02d_%02d',$year,$mon,$day,$hour,$min,$sec);
}

1;
