package Msm::BaseRequest;

use strict;
use Time::Local;
use Msm::IO;
use Msm::Replace;

my $template={
	'i'=>'.i.html',
	'PC'=>'.html'
	};

sub new{
	my $self=shift;
	my $cgi=shift;
	my $config=shift;
	my $io=shift;
	my $hash={};
	bless $hash,$self;
	return $hash;
}

sub setAllData{
	my $self=shift;
	my $data=shift;
	$self->{DATA}=$data;
}

sub dataClear{
	my $self=shift;
	$self->{DATA}={};
}

#ւ[Zbg
sub setHeader{
	my $self=shift;
	my $head=shift;
	$self->{HEADER}=$head;
}

#wb_[o
sub printHeader{
	my $self=shift;
	my $cookie=$self->printCookie();
	if($cookie){
		print 'Set-Cookie: '.$cookie."\n";
	}
	if($self->{HEADER}=~/^Location:\s*(.*)$/i){
		print 'Status: 302'."\n";
		print 'Location: '.$1."\n";
	}elsif($self->{HEADER}=~/^Content-type:\s*(.*)$/i){
		print 'Content-type: '.$1."\n";
	}else{
		print 'Content-type: text/html'."\n";
	}
	print "\n";
}

#F؏
sub getAuth{
	my $self=shift;
	my $t=shift;
	my $file=shift;

	if($t=~/^admin/){
		return $self->checkAuth($file,$self->getUsers());
	}
	return 1;
}

sub getUsers{
	my $self=shift;
	return [];
}

sub rString{
	my $self=shift;
	my $str='';
	for(my $i=0;$i < 24;$i++){
		$str.=int(rand(10));
	}
	return $str;
}

sub authURI{
	my $self=shift;
	if($self->getCGI->param('authid')){
		return 'authid='.$self->getCGI->param('authid');
	}else{
		return '';
	}
}

sub checkAuth{
	my $self=shift;
	my $file=shift;
	my $user=shift;

	if(defined $self->getCGI->SuperParam('adminuser') && defined $self->getCGI->SuperParam('adminpass')){

		foreach my $data(@{$user}){

			if($self->getCGI->param('adminuser') eq $data->{adminuser} && $self->getCGI->param('adminpass') eq $data->{adminpass}){
				if($self->{AuthFileFlg}){return 1;}
				$self->{AuthFileFlg}=1;
				my $id=$self->rString();
				my @line=$self->getIO->readFileArray($file.'.cgi');
				if($data->{config}){
					push @line,$data->{config}->getConfigData('','user').'<>'.$data->{config}->getConfigData('','nickname').'<>'.$id.'<>'.(time);
				}else{
					push @line,$data->{adminuser}.'<>'.$data->{adminuser}.'<>'.$id.'<>'.(time);
				}
				my $out=undef;
				$out.=$_."\n" foreach(@line);

				$self->getIO->writeFile($file.'.cgi',$out);
				unless($self->{Cookie}){
					$self->getCGI->param(-name=>'authid',-value=>$id);
				}
				$self->setCookie('default','authid',$id);
				if($data->{config}){
					$self->getConfig->setConfigDataOverWrite('default','user',$data->{config}->getConfigInfo('default','user'),$data->{config}->getConfigData('default','user'));
					$self->getConfig->setConfigDataOverWrite('default','nickname',$data->{config}->getConfigInfo('default','nickname'),$data->{config}->getConfigData('default','nickname'));
				}else{
					$self->getConfig->setConfigDataOverWrite('default','user','',$data->{adminuser});
					$self->getConfig->setConfigDataOverWrite('default','nickname','',$data->{adminuser});

				}

				return 1;

			}

		}

		$self->getIO->writeFile($file.'.cgi','');
		$self->setCookie('default','authid','');
		return 0;
	}

	if(!($self->getCookieValue('default.authid')) && !($self->getCGI->param('authid'))){

		return 0;
	}
	my @id=$self->getIO->readFileArray($file.'.cgi');
	my @id2=();
	my $ret=0;


	foreach my $iddata(@id){
		chomp $iddata;
		if($iddata eq ''){next;}
		my($u,$nick,$aid,$time)=split(/<>/,$iddata);
		if(($time) + (3600) < time){
			next;
		}
		if($self->getCookieValue('default.authid')){
			if($self->getCookieValue('default.authid') eq $aid){
				$self->getCGI->delete('authid');
				$iddata=$u.'<>'.$nick.'<>'.$aid.'<>'.time;
				$self->getConfig->setConfigDataOverWrite('default','user','',$u);
				$self->getConfig->setConfigDataOverWrite('default','nickname','',$nick);

				$ret=1;
			}
		}else{
			if(($aid) && $self->getCGI->param('authid') eq $aid){
				$iddata=$u.'<>'.$nick.'<>'.$aid.'<>'.time;
				$self->getConfig->setConfigDataOverWrite('default','user','',$u);
				$self->getConfig->setConfigDataOverWrite('default','nickname','',$nick);
				$ret=1;
			}
		}
		push @id2,$iddata;
	}
	my $out=undef;
	$out.=$_."\n" foreach(@id2);

	$self->getIO->writeFile($file.'.cgi',$out);

	return $ret;
}

sub getCGI{
	my $self=shift;
	return $self->{CGI};
}

sub setCGI{
	my $self=shift;
	$self->{CGI}=shift;
}

sub getIO{
	my $self=shift;
	return $self->{IO};
}

sub getConfig{
	my $self=shift;
	return $self->{Config};
}

sub getConfigData{
	my $self=shift;
	my $plug=shift;
	my $name=shift;
	return $self->getConfig->getConfigData($plug,$name);
}

sub tempEscape{
	my $self=shift;
	my $html=shift;
	$html=~s/\[%(.*?)%\]/[%ESCAPE.$1%]/go;

	return $html;
}

#u
#[u邼[[
sub changer{
	my $self=shift;
	my $html=shift;

	my $re=new Msm::Replace($self->getCGI(),$self->getConfig(),$self->getIO,$self->{DATA},$self);
	$html=$re->changer($html);

	return $html;
}

sub changer2 {
	my $self=shift;
	my $html=shift;

	$html=~s/\[\[%%/\[%/gs;
	$html=~s/%%\]\]/%\]/gs;

	$html=$self->changer($html);

	return $html;
}

#LA擾
sub get_ca{
	my $self=shift;
	return $self->{CellPhone}->get_ca();
}

sub set_ca{
	my $self=shift;
	my $ca=shift;
	return $self->{CellPhone}->set_ca($ca);
}


#f[^Zbg
sub setData{
	my $self=shift;
	my $plug=shift;
	my $name=shift;
	my $value=shift;
	$self->{DATA}->{$plug}->{$name}=$value;
}

#f[^Qbg
sub getData{
	my $self=shift;
	my $plug=shift;
	my $name=shift;
	return $self->{DATA}->{$plug}->{$name};
}

#NbL[֘AI
sub getCookieValue(){
	my $self=shift;
	my $key=shift;
	return defined($self->{Cookie}->{$key})?$self->{Cookie}->{$key}:'';
}

sub setNoCookie(){
	my $self=shift;
	$self->{PrintCookie}=0;
}

sub setCookie(){
	my $self=shift;
	my $plugname=shift;
	my $valname=shift;
	my $value=shift;

	$self->{'Cookie'}->{$plugname.'.'.$valname}=$value;
	$self->{PrintCookie}=1;

	return;
}

sub printCookie(){
	my $self=shift;
	my $cookie=$self->{Cookie};
	if($self->{PrintCookie} == 0){
		return undef;
	}
	my $sdir=$self->getConfigData('','script');
	if($sdir=~/(.+)\/(.+)/){
		$sdir=$1;
	}else{
		$sdir='/';
	}
	$cookie=$self->getCGI->cookie(-name=>'MySketch',-value=>\%{$cookie},-path=>$sdir,-expire=>'+100d');
	return $cookie;
}


#err֘A
sub clearErr{
	my $self=shift;
	$self->{Err}=();
}

sub setErr{
	my $self=shift;
	my $mes=shift;
	push @{$self->{Err}},$mes;
}

sub getErrHtml{
	my $self=shift;
	my $html=undef;
	my $endtag=($self->getConfig->getConfigData('default','endtag') eq '1')?' /':'';
	$html.=$_.'<br'.$endtag.'>'."\n" foreach(@{$self->{Err}});
	return $html;
}

sub load_template{
	my $self=shift;
	my $t=shift;
	my $mode=shift;
	my $html='';

	my $ca=$self->get_ca();
	$ca=$mode if $mode;

	my @template=(
		$template->{$ca},
		$template->{i},
		$template->{PC}
		);

	foreach(@template){
		if(-e "$t$_"){
			$html.=$self->{IO}->readFile("$t$_");
			last;
		}
	}

	return $html;
}

sub foot{
	my $self=shift;
	my $html=shift;
	my $foot='
<div class="mysketchwriter">
<p>Generated by <a href="http://www7a.biglobe.ne.jp/~goroh/" title="MySketch GE Ƃ́cc&#13;[J  MySketch 2.7.4 x[X CJH낤 o[WłB&#13;NCGIzzĂ܂B">MySketch&nbsp;GE&nbsp;'.$self->{Version}.'</a></p>
<p>Remodelling origin is <ins datetime="2009-07-28T21:34:13+09:00" title="MySketch 2.7.4̔zzTCg߁AN܂B">MySketch&nbsp;2.7.4</ins></p>
</div>
'."\n";

#gїpy[WHTML\[XăTCYyB
	if($self->get_ca() eq 'i'){
		unless($self->getCGI->param('t') =~ /(admin\/BackUper|admin\/PopUpdater|admin\/WriteDiary)/i){
			$html=~tr/\x09\x0A\x0B\x0C\x0D//d;
		}
		$foot='<div align="right"><p>Generated by <a href="http://www7a.biglobe.ne.jp/~goroh/">MySketch GE '.$self->{Version}.'</a></p></div>';
	}

	my $count1=($html=~s/<\$\sMySketchWriter.print\s\$>/$foot/g);
	my $count2=($html=~s/<\$\sMySketchWriter.none\s\$>//g);
	unless($count1 && $count2){
		$html=~s/(<\/body>)/$foot$1/;
	}

	unless($self->getCGI->param('t') =~ /(admin\/BackUper|admin\/PopUpdater|admin\/WriteDiary)/i){
		$html=~s/\[\[%%\s*([^\t\n\r\f]+)\s*%%\]\]/$self->changer2('[% '.$1.' %]')/egs;
		$html=~s/\\\[/\[/g;
		$html=~s/\\\]/\]/g;
		$html=~s/[\f\n\r]*[ \t]*[\f\n\r]+/\n/go;
	}

	return $html;
}

1;
