package Msm::JCodeFunction;

use strict;

sub new{
	my $self=shift;
	my $ms=shift;
	my $hash={};
	bless $hash,$self;

	my $jcfunc=$ms->getConfigData('default','codefunction');

	if($jcfunc eq '2' || $jcfunc eq '3'){
		eval 'use NKF;';
		unless($@){
			$ms->setConfigData('default','codefunction',$ms->getConfigInfo('default','codefunction'),'2');
			return $hash;
		}
	}
	if($jcfunc eq '1' || $jcfunc eq '3'){
		eval 'use Unicode::Japanese qw(PurePerl);';
		unless($@){
			$ms->setConfigData('default','codefunction',$ms->getConfigInfo('default','codefunction'),'1');
			return $hash;
		}
	}
	require './Msm/msjcode.pl';
	$ms->setConfigData('default','codefunction',$ms->getConfigInfo('default','codefunction'),'0');
	return $hash;
}

sub JCodeConvert{
	my $self=shift;
	my $ms=shift;
	my $string=shift;
	my $ocode=shift;
	my $icode=shift;

	if($ocode eq $icode){return $string;}

	my $jcfunc=$ms->getConfig->getConfigData('default','codefunction');

	if($jcfunc eq '2'){
		my $flag=($ocode eq 'sjis'?'-s':'')||($ocode eq 'utf8'?'-w80':'')||($ocode eq 'euc'?'-e':'')||($ocode eq 'jis'?'-j':'')||'-s';
		$flag.=($icode eq 'sjis'?'S':'')||($icode eq 'utf8'?'W8':'')||($icode eq 'euc'?'E':'')||($icode eq 'jis'?'J':'');
		return nkf($flag,$string);
	}
	if($jcfunc eq '1'){
		return ($icode ne '')?Unicode::Japanese->new($string,$icode)->conv($ocode):Unicode::Japanese->new($string,'auto')->conv($ocode);
	}
	if($icode ne ''){
		&jcode'convert(\$string,$ocode,$icode);
	}
	else{
		&jcode'convert(\$string,$ocode);
	}
	return $string;
}

sub JCodeGet{
	my $self=shift;
	my $ms=shift;
	my $string=shift;

	my $jcfunc=$ms->getConfig->getConfigData('default','codefunction');

	my $code;
	if($jcfunc eq '2'){
		return '';
	}
	if($jcfunc eq '1'){
		$code=Unicode::Japanese->new('')->getcode($string);
	}
	else{
		my $match;
		($match,$code)=&jcode'getcode(\$string);
		$code='euc' if $code eq undef and $match > 0;
	}
	if($code eq 'euc'){
		if($string !~ /^(?:[\241-\376][\241-\376]|\216[\241-\337]|\217[\241-\376][\241-\376]|[\x00-\x7F])*$/){
			if($string =~ /^(?:[\201-\237\340-\374][\100-\176\200-\374]|[\241-\337]|[\x00-\x7F])*$/){
				$code='sjis';
			}
		}
	}
	return $code;
}

1;
