package Msm::MySketch;

use strict;
use Time::Local;
use Msm::IO;
use Msm::CellPhone;
use Msm::RSS;
use Msm::StaticHtml;
use base qw(Msm::BaseRequest);

#use Time::HiRes qw/gettimeofday tv_interval/;

sub new{
	my $self=shift;
	my $cgi=shift;
	my $config=shift;
	my $io=shift;
	my $adconfig=shift;
	my $db=shift;
	my $jcode=shift;
	my $hash={};
	bless $hash,$self;
	$hash->{NewFile}= undef;
	$hash->{GetDataDirAll}= undef;
	$hash->{GetDataFile}= undef;
	$hash->{GetDataFileAll}= undef;
	$hash->{PrintCookie}= 0;
	$hash->{CGI}=$cgi;
	$hash->{DB}=$db;
	$hash->{CellPhone}=new Msm::CellPhone();
	$hash->{DATA}=undef;
	$hash->{HEADER}='Content-type: text/html';
	$hash->{Err}=();
	$hash->{Config}=$config;
	$hash->{AdConfig}=$adconfig;
	$hash->{IO}=$io;
	$hash->{plugin}=undef;
	$hash->{Version}='1.4.1';
	$hash->{AuthFileFlg}=0;
	$hash->{JCode}=$jcode;

	if($adconfig->getConfigData('','savename') eq ''){
		$adconfig->setConfigDataOverWrite('default','savename',$adconfig->getConfigInfo('default','savename'),'File');
	}
	#$adconfig->setConfigDataOverWrite('default','plugdir','','MsmPlug');
	eval('use Msm::MySketch::'.$adconfig->getConfigData('','savename').';');
	eval('$hash->{DBCLASS}=new Msm::MySketch::'.$adconfig->getConfigData('','savename').'($hash);');

	#KvȃRtBO⊮B
	$config->setConfigDataOverWrite('default','script',$adconfig->getConfigInfo('default','script'),$adconfig->getConfigData('default','script'));
	#$config->setConfigDataOverWrite('EazyAnalyzer','anascript',$adconfig->getConfigInfo('default','anascript'),$adconfig->getConfigData('default','anascript'));

	my %cook=$hash->{CGI}->cookie(-name=>'MySketch');
	foreach(keys %cook){
		$hash->{Cookie}->{$_}=$cook{$_};
	}
	#version⊮
	$config->setConfigData('default','rsscode','ATOM/RSSR[h<br>0:Shift_JIS<br>1:UTF-8','0');

	if($config->getConfigData('','usefileinfo') eq '1'){
		$hash->readFileInfo();
	}

	#gݒ()
	$config->setConfigData('default','codefunction','D悵ē{̕R[hvO<br>0:msjcode.pl<br>1:Unicode::Japanese<br>2:NKF<br>3:NKFiUnicode::Japanesej','0');
	$config->setConfigData('default','endtag','I^Ö<br>0:HTML<br>1:XHTML','0');
	$config->setConfigData('default','lcencode','N`FbN̓{̕R[hϊ<br>0:ϊȂ<br>1:EUC-JPɕϊă`FbNAVtgJISɖ߂<br>\[XsłȂꍇ́u1v𐄏B','0');
	$config->setConfigData('default','maintenance','eiXݒ<br>0:ʏ^p<br>1:eiX','0');
	$config->setConfigData('default','Sitemap','XML TCg}bv<br>0:o͂Ȃ<br>1:o͂<br>uATOM/RSS/XML TCg}bvóv炢ło͉\łB<br>uLҏWATOM/RSSXVvsꍇ́ALҏW̃^C~OXML TCg}bvo͂ł܂B','1');
	$config->setConfigData('default','rssnocreate','LҏWATOM/RSSXV<br>0:XVȂ<br>1:XV<br>uATOM/RSS/XML TCg}bvóv炢łXV\łB','1');
	$hash->{DATA}->{'MySketch'}->{'generator'}='MySketch GE '.$hash->{Version};
	$hash->{DATA}->{'OutRSS'}->{'disabled'}='disabled';
	#gݒ(܂)

	$ENV{'TZ'}='JST-9';

	return $hash;
}

sub getVersion{
	my $self=shift;
	return $self->{Version};
}

sub setVersion{
	my $self=shift;
	my $var=shift;
	$self->{Version}=$var;
}

sub getDB{
	my $self=shift;
	return $self->{DB};
}

sub getAuth{
	my $self=shift;
	my $t=shift;
	if($self->getConfig->{FILENAME} eq 'Config'){
		return $self->SUPER::getAuth($t,'./ini/id');
	}else{
		return $self->SUPER::getAuth($t,$self->getAdConfigData('userdatadir').'/'.$self->getCGI->param('blogid').'/ini/id');
	}
}

sub checkAuth{
	my $self=shift;
	my $ret=undef;
	my $data=$self->getUsers();
	if($self->getConfig->{FILENAME} eq 'Config'){
		$ret=$self->SUPER::checkAuth('./ini/id',$data);
	}else{
		$ret=$self->SUPER::checkAuth($self->getAdConfigData('userdatadir').'/'.$self->getCGI->param('blogid').'/ini/id',$data);
	}
	return $ret;
}

sub getUsers{
	my $self=shift;
	if($self->getConfig->{FILENAME} eq 'Config'){
		my @user=();
		push @user,{adminuser=>$self->getConfigData('','adminuser'),adminpass=>$self->getConfigData('','adminpass')};
		return \@user;
	}else{
		my $blogid=$self->getCGI->param('blogid');
		my $config=new Msm::Config('bloguser_'.$blogid,$self->getAdConfig(),$self->getDB());
		my $users=$config->getConfigData('','blogusers');
		my @user=();
		foreach my $data(@{$users}){
			my $uconfig=new Msm::Config('user_'.$data,$self->getAdConfig(),$self->getDB());
			push @user,{adminuser=>$uconfig->getConfigData('','user'),adminpass=>$uconfig->getConfigData('','pass'),config=>$uconfig};
		}
		return \@user;
	}

}

sub getDataDir{
	my $self=shift;
	if($self->getConfig->{FILENAME} eq 'Config'){
		return $self->getConfig->getConfigData('','datadir');
	}else{
		return $self->getAdConfigData('userdatadir').'/'.$self->getCGI->param('blogid').'/data';
	}
}

sub getPlugDataDir{
	my $self=shift;
	if($self->getConfig->{FILENAME} eq 'Config'){
		return $self->getConfig->getConfigData('','plugdatadir');
	}else{
		return $self->getAdConfigData('userdatadir').'/'.$self->getCGI->param('blogid').'/plugdata';
	}
}

sub getTempDataDir{
	my $self=shift;
	if($self->getConfig->{FILENAME} eq 'Config'){
		return $self->getConfig->getConfigData('','tempdir');
	}else{
		return $self->getAdConfigData('userdatadir').'/'.$self->getCGI->param('blogid').'/template';
	}
}

sub getAdConfigData{
	my $self=shift;
	my $name=shift;
	return $self->getAdConfig->getConfigData('default',$name);
}

sub getAdConfig{
	my $self=shift;
	return $self->{AdConfig};
}

sub getUserConfig{
	my $self=shift;
	return $self->{UserConfig};
}

sub getUserConfigData{
	my $self=shift;
	my $name=shift;
	return $self->getUserConfig->getConfigData('default',$name);
}


sub load_template{
	my $self=shift;
	my $t=shift;
	my $mode=shift;
	my $html='';
	$html=$self->SUPER::load_template($self->getTempDataDir().'/'.$t,$mode);

	return $html;

}

sub plugin_init{
	my $self=shift;

	my $onplug=$self->getConfig->getConfigData('','onplugins');
	my @onplug=();
	if($onplug){
		@onplug=@{$onplug};
	}
	my $on={};
	my $onflg=0;
	if(!(@onplug) || $#onplug == 0){
	}else{
		$onflg=1;
		foreach(@onplug){
			$on->{$_}=1;
		}

	}

	unless($self->{plugin}){

		opendir DIR,'MsmPlug';
		my @plug=readdir DIR;
		foreach my $entry(sort(@plug)){
			if($entry eq '.' || $entry eq '..' || $entry =~ /\./){
				next;
			}
			if(($onflg) && !($on->{$entry})){
				push @{$self->{plugin}},{name=>$entry,view=>0};
			}else{
				require "MsmPlug/$entry";
				push @{$self->{plugin}},{name=>$entry,view=>1};
			}
		}
		closedir(DIR);
	}else{
		foreach my $plug(@{$self->{plugin}}){
			if(($onflg) && !($on->{$plug->{name}})){
				$plug->{view}=0;
			}else{
				$plug->{view}=1;
			}
		}
	}
	foreach my $plug(@{$self->{plugin}}){
		if($plug->{view} != 1){
			next;
		}
		my $ret={};
		eval('$ret=&MsmPlug::'.$plug->{name}.'::init($plug->{name},$self);');
		$plug->{view}=$ret->{OK};
		$plug->{ref}=$ret;
		if($onflg == 0){
			if(defined($ret->{OFF}) && $ret->{OFF} == 1){
				$plug->{view}=0;
				$plug->{OFF}=1;
			}
		}
		if($@){
			$self->setErr($@);
		}
	}
}

sub plugin_execute{
	my $self=shift;
	my $hash=shift;
	my $ch={};

	foreach my $plug(@{$self->{plugin}}){
		if($self->{Err}){
			last;
		}
		if($plug->{view} != 1){
			next;
		}
		#my $start=[gettimeofday];
		eval('&MsmPlug::'.$plug->{name}.'::execute($plug->{ref});');
		#my $end=[gettimeofday];
		#my $speed=tv_interval($start, $end);
		#printf "plug in execute time($plug->{name}) %.6f b<br>\n", $speed;
		if($@){
			$self->setErr('init error '.$@);
		}
	}
}

sub plugin_change{
	my $self=shift;
	my $html=shift;
	my $ch={};
	foreach my $plug(@{$self->{plugin}}){
		if($self->{Err}){
			last;
		}
		if($plug->{view} != 1){
			next;
		}
		my $tmp='';
		eval('$tmp=&MsmPlug::'.$plug->{name}.'::change($plug->{ref});');
		$html=$tmp if($tmp);
		if($@){
			$self->setErr($@);
		}
	}
	return $html;
}

#f[^Zbg
sub setData{
	my $self=shift;
	my $plug=shift;
	my $name=shift;
	my $value=shift;
	$self->{DATA}->{$plug}->{$name}=$value;
}

#f[^Qbg
sub getData{
	my $self=shift;
	my $plug=shift;
	my $name=shift;
	return $self->{DATA}->{$plug}->{$name};
}

#Lt@Cǂݍ
sub getSketchFiles{
	my $self=shift;
	my $dir=shift;	#fBNgw
	my $file=shift;	#t@Cw
	my $s_date=shift;	#Jnt
	my $e_date=shift; #It

	return $self->{DBCLASS}->getSketchFiles($dir,$file,$s_date,$e_date);

}

sub getSketchData{
	my $self=shift;
	my $file=shift;
	my $dhash=shift;
	return $self->{DBCLASS}->getSketchData($file,$dhash);
}


#SfBNg擾
sub getAllDirs{
	my $self=shift;
	my $dir=shift;
	my $dircheck=shift;

	return $self->{DBCLASS}->getAllDirs($dir,$dircheck);
}

#LbVgȂǂݍ
sub getAllDirsNoCache{
	my $self=shift;
	my $dir=shift;
	my $dircheck=shift;

	return $self->{DBCLASS}->getAllDirsNoCache($dir,$dircheck);
}


#LfBNgǂݍ
sub getDirs{
	my $self=shift;
	my $dir=shift;
	my $dirs=shift;
	return $self->{DBCLASS}->getDirs($dir,$dirs);
}

#fBNgLǂݍ
sub getDirFiles{
	my $self=shift;
	my $dir=shift;
	my $files=shift;

	return $self->{DBCLASS}->getDirFiles($dir,$files);
}

sub getDirFilesData{
	my $self=shift;
	my $dir=shift;
	return $self->{DBCLASS}->getDirFilesData($dir);
}

sub getDirCnt{
	my $self=shift;
	my $dir=shift;
	return $self->{DBCLASS}->getDirCnt($dir);
}

#Lǂݍ
sub getDirFile{
	my $self=shift;
	my $dir=shift;
	my $entry=shift;
	my $files=shift;
	my $cache=shift;

	return $self->{DBCLASS}->getDirFile($dir,$entry,$files,$cache);
}


sub clearCache{
	my $self=shift;
	$self->{GetDataFile}=undef;
	$self->{GetDataFileAll}=undef;
	$self->{GetDataDirAll}=undef;
}

sub deleteCache{
	my $self=shift;
	my $fullname=shift;
	my $ddir=$self->getDataDir();
	if($fullname =~ /\.txt$/){
		if($self->{GetDataFileAll}){
			delete $self->{GetDataFileAll}->{$fullname};
		}
		if($self->{GetDataFile}){
			if($fullname=~/^($ddir\/.+)\/.+/){
				my $tmp=$1;
				delete $self->{GetDataFile}->{$tmp}->{$fullname};
			}
		}
	}else{
		if($self->{GetDataDirAll}){
			delete $self->{GetDataDirAll}->{$fullname};
		}
	}
}

#LbV̕ύX
sub changeCache{
	my $self=shift;
	my $fullname=shift;

	return $self->{DBCLASS}->changeCache($fullname);

}

#Vf[^擾
sub getNewSketchData{
	my $self=shift;
	my $name=shift;
	return $self->{NewFile}->{$name};
}

#L֘A
sub createSketch{
	my $self=shift;
	my $dir=shift;
	my $file=shift;
	my $title=shift;
	my $comment=shift;
	my $date=shift;

	return $self->{DBCLASS}->createSketch($dir,$file,$title,$comment,$date);
}

sub createSketchNoRemake{
	my $self=shift;
	my $dir=shift;
	my $file=shift;
	my $title=shift;
	my $comment=shift;
	my $date=shift;

	return $self->{DBCLASS}->createSketchNoRemake($dir,$file,$title,$comment,$date);
}

#폜
sub clearSketchAndDir{
	my $self=shift;
	my $file=shift;

	return $self->{DBCLASS}->clearSketchAndDir($file);

}

sub clearSketchAndDirNoRemake{
	my $self=shift;
	my $file=shift;

	return $self->{DBCLASS}->clearSketchAndDirNoRemake($file);

}

#L̈ړ
sub moveSketch{
	my $self=shift;
	my $mfile=shift;
	my $gofile=shift;

	my $godir=$gofile;
	$godir=~s/^(.*)\/.+/$1/;

	my $datahash=$self->getSketchData($self->getDataDir().$mfile);
	$self->clearSketchAndDirNoRemake($mfile);
	my ($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdst)=localtime($datahash->{date});
	$year+=1900;
	$mon++;

	$self->createSketchNoRemake($godir,$datahash->{file},$datahash->{title},$datahash->{comment},sprintf('%04d%02d%02d%02d%02d%02d',$year,$mon,$day,$hour,$min,$sec));

	#vOf[^̈ړȂƂȂ́BB
	foreach my $plug(@{$self->{plugin}}){
		if($self->{Err}){
			last;
		}
		if(defined $plug->{MoveEvent} && $plug->{MoveEvent} == 0){
			next;
		}
		eval('&MsmPlug::'.$plug->{name}.'::moveEvent($plug->{ref},$mfile,$gofile);');
		if($@){
			$plug->{MoveEvent}=0;
		}else{
			$plug->{MoveEvent}=1;
		}
	}
}

#fileinfo֘A
sub createFileInfo{
	my $self=shift;

	return $self->{DBCLASS}->createFileInfo();
}

sub createFileInfoFromCache{
	my $self=shift;
	return $self->{DBCLASS}->createFileInfoFromCache();
}

sub readFileInfo{
	my $self=shift;
	return $self->{DBCLASS}->readFileInfo();
}


#쐬֘A
sub createDataDir{
	my $self=shift;
	my $file=shift;
	my $date=shift;
	return $self->{DBCLASS}->createDataDir($file,$date);
}

sub updateDataDir{
	my $self=shift;
	my $dir=shift;
	my $date=shift;
	return $self->{DBCLASS}->updateDataDir($dir,$date);
}

#vOC֌W
sub createPlugDir{
	my $self=shift;
	my $plug=shift;
	my $dir=shift;
	$self->{DBCLASS}->createPlugDir($plug,$dir);
}

sub getPlugDirs{
	my $self=shift;
	my $dir=shift;
	my $dircheck=shift;
	return $self->{DBCLASS}->getPlugDirs($dir,$dircheck);
}

sub getPlugDirFiles{
	my $self=shift;
	my $dir=shift;
	my $files=shift;

	return $self->{DBCLASS}->getPlugDirFiles($dir,$files);
}

sub readPlugData{
	my $self=shift;
	my $plug=shift;
	my $dir=shift;
	my $file=shift;
	return $self->{DBCLASS}->readPlugData($plug,$dir,$file);
}

sub writePlugData{
	my $self=shift;
	my $plug=shift;
	my $dir=shift;
	my $file=shift;
	my $data=shift;
	$self->{DBCLASS}->writePlugData($plug,$dir,$file,$data);
}

sub existsPlugData{
	my $self=shift;
	my $plug=shift;
	my $dir=shift;
	my $file=shift;

	return $self->{DBCLASS}->existsPlugData($plug,$dir,$file);
}

sub deletePlugData{
	my $self=shift;
	my $plug=shift;
	my $dir=shift;
	my $file=shift;

	return $self->{DBCLASS}->deletePlugData($plug,$dir,$file);
}

#̃`FbN
sub CheckTime{
	my $self=shift;
	my $time=shift;

	if($time !~ /^\d{14}$/){return 0;}
	if($time < 19700101090001 || $time > 20380119121407){return 0;}

	my $dy=substr($time,0,4);
	my $dm=substr($time,4,2);
	my $dd=substr($time,6,2);
	my $dh=substr($time,8,2);
	my $dmin=substr($time,10,2);
	my $ds=substr($time,12,2);
	my $ly=(($dy % 4 == 0) && ($dy % 100 != 0) || ($dy % 400 == 0))?1:0;
	if($dm < 1 || $dm > 12 || $dd < 1 || $dd > 31 || $dh > 23 || $dmin > 59 || $ds > 59){return 0;}
	if($dm == 2 && $dd > 28+$ly){return 0;}
	if(($dm == 4 || $dm == 6 || $dm == 9 || $dm == 11) && $dd > 30){return 0;}
	return timelocal($ds,$dmin,$dh,$dd,$dm-1,$dy);
}

#Ǘc[j[
sub addAdminMenu{
	my $self=shift;
	my $link=shift;
	my $text=shift;

	my $data=$self->getData('AdminMenu','menu');
	unless($data){
		$data=[];
	}
	push @{$data},{link=>$link,text=>$text};
	$self->setData('AdminMenu','menu',$data);
}

1;
