package Msm::RSS;

use strict;
use Time::Local;
use Msm::Replace;

sub new{
	my $self=shift;
	my $hash={};
	bless $hash,$self;
	return $hash;
}

sub changer{
	my $self=shift;
	my $ms=shift;
	my $html=shift;

	my $re=new Msm::Replace($ms->{CGI},$ms->{Config},$ms->{IO},$ms->{DATA},$ms);
	$html=$re->changer($html);

	return $html;
}

sub changer2 {
	my $self=shift;
	my $ms=shift;
	my $html=shift;

	$html=~s/\[\[%%/\[%/gs;
	$html=~s/%%\]\]/%\]/gs;

	$html=$self->changer($ms,$html);

	return $html;
}

sub createSketchRSS{
	my $self=shift;
	my $ms=shift;
	my $file=shift;
	my $rsscode=shift;
	my $sitemap_out=shift;
	my %file=%{$file};

	$sitemap_out=$sitemap_out||($ms->getConfig->getConfigData('default','Sitemap') eq '1');

	my @rss=();
	my @file_data=();
	my @file_date=();
	my $i=0;
	my $rss_cnt=$ms->getConfig->getConfigData('default','rsscnt')+$[;
	my $rss_length=$ms->getConfig->getConfigData('','rsslength');
	my $datadir=$ms->getDataDir();
	my $plug_dir=$ms->getConfig->getConfigData('default','plugdatadir');
	my $jcode=$ms->{JCode};
	my $now_time=time;
	my $plug_WDUser=undef;
	foreach my $chk_plug(@{$ms->{plugin}}){
		if($chk_plug->{name} eq 'WriteDiaryUser'){
			$plug_WDUser=($chk_plug->{view} == 1);
			last;
		}
	}
	if($rss_cnt == 0){
		$rss_cnt=keys(%file);
	}
	foreach my $v(sort {$file{$b} <=> $file{$a}} keys %file){
		my $uptime=$file{$v};
		my ($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdst)=localtime($uptime);
		$year+=1900;
		$mon++;
		$mon=sprintf('%02d',$mon);
		$day=sprintf('%02d',$day);
		$hour=sprintf('%02d',$hour);
		$min=sprintf('%02d',$min);
		$sec=sprintf('%02d',$sec);
		my $chash={};

		my $fdctime=$year.'-'.$mon.'-'.$day.'T'.$hour.':'.$min.':'.$sec.'+09:00';

		$v=~/^$datadir(.*)\/(.*)\.txt$/;
		my $filename=$2;
		my $dirname=$1;

		my $fuptime=$fdctime;
		my $WDUser_text=$plug_dir.'/WriteDiaryUser'.$dirname.'/'.$filename.'.txt';
		if(-f $WDUser_text){
			$uptime=(stat $WDUser_text)[9];
			($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdst)=localtime($uptime);
			$year+=1900;
			$mon++;
			$mon=sprintf('%02d',$mon);
			$day=sprintf('%02d',$day);
			$hour=sprintf('%02d',$hour);
			$min=sprintf('%02d',$min);
			$sec=sprintf('%02d',$sec);

			$fuptime=$year.'-'.$mon.'-'.$day.'T'.$hour.':'.$min.':'.$sec.'+09:00';
		}

		my $time_difference=$now_time-$uptime;

		$chash={
			full_name=>$v,
			year=>$year,
			mon=>$mon,
			day=>$day,
			hour=>$hour,
			min=>$min,
			file=>$filename,
			dir=>$dirname,
			dctime=>$fdctime,
			uptime=>$fuptime,
			time_df=>$time_difference
		};

		push @file_data, $chash;
		push @file_date, $time_difference;
	}

	@file_data=@file_data[sort {$file_date[$a] <=> $file_date[$b]} 0 .. $#file_date];
	undef @file_date;

	foreach my $v(@file_data){
		my $ret=$ms->getSketchData($v->{full_name});

		my $filename=$v->{file};
		my $dirname=$v->{dir};
		my $time_difference=$v->{time_df};

		my $chash={};
		my $title=$ret->{title};
		$title=~s/(\r\n|\n)$//;

		my $author=$plug_WDUser?($ms->readPlugData('WriteDiaryUser',$dirname,$filename.'.txt'))[0]:'no name';

		my $period=($time_difference < 604800?'daily':'')||($time_difference < 2629746?'weekly':'')||($time_difference < 31556952?'monthly':'')||'yearly';

		my $come='';
		if($i < $rss_cnt){
		$i++;
			$come=$ret->{comment};
			$come=~s/\[\[%%\s*([^\t\n\r\f]+)\s*%%\]\]/$self->changer2($ms,'[% '.$1.' %]')/egs;
			$come=~s/\\\[/\[/g;
			$come=~s/\\\]/\]/g;
			$come=~s/^------.*?$//gm;
			$come=~tr/\x0D\x0A//d;
			$come=~s/<.*?>//g;

			#
			$come=$jcode->JCodeConvert($ms,$come,'euc','sjis');
			if(length($come) > $rss_length){
				my $str=substr($come,0,$rss_length);
				if($str =~ /\x8F$/ or $str =~ tr/\x8E\xA1-\xFE// % 2){
					$str=substr($come,0,($rss_length+1));
					if($str =~ /\x8F$/ or $str =~ tr/\x8E\xA1-\xFE// % 2){
						$str=substr($come,0,($rss_length+2));
					}
				}
				$come=$str.'...';
			}
			$come=$jcode->JCodeConvert($ms,$come,'sjis','euc');
		};

		$chash={
			title=>$ms->getCGI->escapeHTML($title),
			show=>$ms->getCGI->escapeHTML($come),
			year=>$v->{year},
			mon=>$v->{mon},
			day=>$v->{day},
			hour=>$v->{hour},
			min=>$v->{min},
			file=>$filename,
			dir=>$dirname,
			dctime=>$v->{dctime},
			uptime=>$v->{uptime},
			period=>$period,
			author=>$author
		};

		push @rss,$chash;
	}

	undef @file_data;

	if($rss_cnt > $#rss+1-$[){
		$rss_cnt=$#rss+1-$[;
	}

	my $msname=$ms->getCGI->escapeHTML($ms->getConfig->getConfigData('default','msname'));

	my $script=$ms->getAdConfig->getConfigData('','script');
	my $script_url=$script;
	my $blogid=$ms->getCGI->param('blogid');

	my $sketch_mode='0';
	my $index_mode='0';
	if($ms->getConfig->getConfigData('default','staticmode') eq '1'){
		$sketch_mode=$ms->getConfig->getConfigData('default','staticmode_sketch');
		$index_mode=$ms->getConfig->getConfigData('default','staticmode_index');
	}
	my $index_html_dir=$ms->getConfig->getConfigData('default','staticindexdir');
	my $index_html_url=$ms->getConfig->getConfigData('default','staticindexurl');

	my $generator_url='http://www7a.biglobe.ne.jp/~goroh/';

	my $link_host='http://'.$ENV{HTTP_HOST};
	my $link_index=$link_host;
	my $site_url=$link_host.$index_html_url;
	my $link_sketch='';
	my $sketch_id='';
	my $period='';

	#rsso
	my $code='utf-8';
	if($rsscode ne '1'){
		$code='Shift_JIS';
		$script_url=~s/~/%7E/g;
		$index_html_url=~s/~/%7E/g;
		$generator_url=~s/~/%7E/g;
	}

	my $time_difference=$now_time;
	if($index_mode eq '1'){
		$link_index.=$index_html_url.'index.html';
		my $index_html=$index_html_dir.'index.html';
		if(-f $index_html){
			$now_time=(stat $index_html)[9];
		}
	}
	else{
		$link_index.=$script.'?blogid='.$blogid;
	}
	$time_difference-=$now_time;
	my $period=($time_difference < 604800?'daily':'')||($time_difference < 2629746?'weekly':'')||($time_difference < 31556952?'monthly':'')||'yearly';

	my $link_rdf=$link_host.$index_html_url.'mysketch.rdf';
	my $link_atom=$link_host.$index_html_url.'mysketch_atom.xml';
	my $adminuser=$ms->getConfig->getConfigData('default','adminuser');

	my ($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdst)=localtime($now_time);
	$year+=1900;
	$mon++;
	$mon=sprintf('%02d',$mon);
	$day=sprintf('%02d',$day);
	$hour=sprintf('%02d',$hour);
	$min=sprintf('%02d',$min);
	$sec=sprintf('%02d',$sec);
	my $dctime=$year.'-'.$mon.'-'.$day.'T'.$hour.':'.$min.':'.$sec.'+09:00';

	#$ENV{'TZ'}=$envtmp;
my $xml=<<XML;
<?xml version="1.0" encoding="$code"?>
<rdf:RDF
	xmlns="http://purl.org/rss/1.0/"
	xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
	xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns:sy="http://purl.org/rss/modules/syndication/"
	xml:lang="ja">
 <channel rdf:about="$link_rdf">
  <title>$msname</title>
  <link>$link_index</link>
  <description />
  <dc:date>$dctime</dc:date>
  <items>
   <rdf:Seq>
XML

my $atom=<<XML;
<?xml version="1.0" encoding="$code"?>
<feed xmlns="http://www.w3.org/2005/Atom" xml:lang="ja">
  <title>$msname</title>
  <updated>$dctime</updated>
  <id>$site_url</id>
  <link rel="alternate" type="text/html" hreflang="ja" href="$link_host$index_html_url" />
  <link rel="self" type="application/atom+xml" href="$link_atom" />
  <generator uri="$generator_url" version="$ms->{Version}">MySketch GE</generator>
XML


	if($sketch_mode eq '1'){
		for($i=$[;$i < $rss_cnt;$i++){
			$link_sketch=$link_host.$index_html_url.'category'.$rss[$i]->{dir}.'/'.$rss[$i]->{file}.'.html';
$xml.=<<XML;
    <rdf:li rdf:resource="$link_sketch"/>
XML
		}
	}
	else{
		for($i=$[;$i < $rss_cnt;$i++){
			$link_sketch=$link_host.$script.'?t=sketch&amp;blogid='.$blogid.'&amp;ShowDiary_file='.$rss[$i]->{dir}.'/'.$rss[$i]->{file};
$xml.=<<XML;
    <rdf:li rdf:resource="$link_sketch"/>
XML
		}
	}

$xml.=<<XML;
   </rdf:Seq>
  </items>
 </channel>
XML


	if($sitemap_out){
#XML TCg}bvȍ͎
my $sitemap=<<XML;
<?xml version="1.0" encoding="UTF-8"?>
<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">
	<url>
		<loc>$link_index</loc>
		<lastmod>$dctime</lastmod>
		<changefreq>$period</changefreq>
	</url>
XML


		if($sketch_mode eq '1'){
			for($i=$[;$i < $rss_cnt;$i++){
				$sketch_id=$site_url.'category'.$rss[$i]->{dir}.'/'.$rss[$i]->{file}.'.html';
				$link_sketch=$link_host.$index_html_url.'category'.$rss[$i]->{dir}.'/'.$rss[$i]->{file}.'.html';
$xml.=<<XML;
 <item rdf:about="$link_sketch">
  <title>$rss[$i]->{title}</title>
  <link>$link_sketch</link>
  <description>$rss[$i]->{show}</description>
  <dc:date>$rss[$i]->{dctime}</dc:date>
 </item>
XML

$atom.=<<XML;
  <entry>
    <id>$sketch_id</id>
    <title>$rss[$i]->{title}</title>
    <link rel="alternate" type="text/html" href="$link_sketch" />
    <summary>$rss[$i]->{show}</summary>
    <published>$rss[$i]->{dctime}</published>
    <updated>$rss[$i]->{uptime}</updated>
    <author>
      <name>$rss[$i]->{author}</name>
    </author>
  </entry>
XML

$sitemap.=<<XML;
	<url>
		<loc>$link_sketch</loc>
		<lastmod>$rss[$i]->{uptime}</lastmod>
		<changefreq>$rss[$i]->{period}</changefreq>
	</url>
XML
			}
		}
		else{
			for($i=$[;$i < $rss_cnt;$i++){
				$sketch_id=$link_host.$script.'?t=sketch&amp;blogid='.$blogid.'&amp;ShowDiary_file='.$rss[$i]->{dir}.'/'.$rss[$i]->{file};
				$link_sketch=$link_host.$script_url.'?t=sketch&amp;blogid='.$blogid.'&amp;ShowDiary_file='.$rss[$i]->{dir}.'/'.$rss[$i]->{file};
$xml.=<<XML;
 <item rdf:about="$link_sketch">
  <title>$rss[$i]->{title}</title>
  <link>$link_sketch</link>
  <description>$rss[$i]->{show}</description>
  <dc:date>$rss[$i]->{dctime}</dc:date>
 </item>
XML

$atom.=<<XML;
  <entry>
    <id>$sketch_id</id>
    <title>$rss[$i]->{title}</title>
    <link rel="alternate" type="text/html" href="$link_sketch" />
    <summary>$rss[$i]->{show}</summary>
    <published>$rss[$i]->{dctime}</published>
    <updated>$rss[$i]->{uptime}</updated>
    <author>
      <name>$rss[$i]->{author}</name>
    </author>
  </entry>
XML

$sitemap.=<<XML;
	<url>
		<loc>$link_sketch</loc>
		<lastmod>$rss[$i]->{uptime}</lastmod>
		<changefreq>$rss[$i]->{period}</changefreq>
	</url>
XML
			}
		}


$xml.=<<XML;
</rdf:RDF>
XML

$atom.=<<XML;
</feed>
XML


		if($rsscode eq '1'){
			#utf8ɃGR[h
			$xml=$jcode->JCodeConvert($ms,$xml,'utf8','sjis');
			$atom=$jcode->JCodeConvert($ms,$atom,'utf8','sjis');
		}
		$ms->getIO->writeFile($index_html_dir.'mysketch.rdf',$xml);
		$ms->getIO->writeFile($index_html_dir.'mysketch_atom.xml',$atom);
		undef $xml;
		undef $atom;


		if($rss_cnt <= $#rss - $[){
			if($sketch_mode eq '1'){
				for($i=$rss_cnt;$i <= $#rss;$i++){
					$link_sketch=$link_host.$index_html_url.'category'.$rss[$i]->{dir}.'/'.$rss[$i]->{file}.'.html';
$sitemap.=<<XML;
	<url>
		<loc>$link_sketch</loc>
		<lastmod>$rss[$i]->{uptime}</lastmod>
		<changefreq>$rss[$i]->{period}</changefreq>
	</url>
XML
				}
			}
			else{
				for($i=$[;$i < $rss_cnt;$i++){
					$link_sketch=$link_host.$script.'?t=sketch&amp;blogid='.$blogid.'&amp;ShowDiary_file='.$rss[$i]->{dir}.'/'.$rss[$i]->{file};
$sitemap.=<<XML;
	<url>
		<loc>$link_sketch</loc>
		<lastmod>$rss[$i]->{uptime}</lastmod>
		<changefreq>$rss[$i]->{period}</changefreq>
	</url>
XML
				}
			}
		}


$sitemap.=<<XML;
</urlset>
XML


		$ms->getIO->writeFile($index_html_dir.'sitemap.xml',$sitemap);


		if($index_mode eq '1' || $sketch_mode eq '1'){
			$sitemap=~s/\.html<\/link>$/\.i\.html<\/link>/gm;
		}
		$ms->getIO->writeFile($index_html_dir.'mobile_sitemap.xml',$sitemap);
	}
	else{
#XML TCg}bvo͂ȂƂ̏
		if($sketch_mode eq '1'){
			for($i=$[;$i < $rss_cnt;$i++){
				$sketch_id=$site_url.'category'.$rss[$i]->{dir}.'/'.$rss[$i]->{file}.'.html';
				$link_sketch=$link_host.$index_html_url.'category'.$rss[$i]->{dir}.'/'.$rss[$i]->{file}.'.html';
$xml.=<<XML;
 <item rdf:about="$link_sketch">
  <title>$rss[$i]->{title}</title>
  <link>$link_sketch</link>
  <description>$rss[$i]->{show}</description>
  <dc:date>$rss[$i]->{dctime}</dc:date>
 </item>
XML

$atom.=<<XML;
  <entry>
    <id>$sketch_id</id>
    <title>$rss[$i]->{title}</title>
    <link rel="alternate" type="text/html" href="$link_sketch" />
    <summary>$rss[$i]->{show}</summary>
    <published>$rss[$i]->{dctime}</published>
    <updated>$rss[$i]->{uptime}</updated>
    <author>
      <name>$rss[$i]->{author}</name>
    </author>
  </entry>
XML
			}
		}
		else{
			for($i=$[;$i < $rss_cnt;$i++){
				$sketch_id=$link_host.$script.'?t=sketch&amp;blogid='.$blogid.'&amp;ShowDiary_file='.$rss[$i]->{dir}.'/'.$rss[$i]->{file};
				$link_sketch=$link_host.$script_url.'?t=sketch&amp;blogid='.$blogid.'&amp;ShowDiary_file='.$rss[$i]->{dir}.'/'.$rss[$i]->{file};
$xml.=<<XML;
 <item rdf:about="$link_sketch">
  <title>$rss[$i]->{title}</title>
  <link>$link_sketch</link>
  <description>$rss[$i]->{show}</description>
  <dc:date>$rss[$i]->{dctime}</dc:date>
 </item>
XML

$atom.=<<XML;
  <entry>
    <id>$sketch_id</id>
    <title>$rss[$i]->{title}</title>
    <link rel="alternate" type="text/html" href="$link_sketch" />
    <summary>$rss[$i]->{show}</summary>
    <published>$rss[$i]->{dctime}</published>
    <updated>$rss[$i]->{uptime}</updated>
    <author>
      <name>$rss[$i]->{author}</name>
    </author>
  </entry>
XML
			}
		}


$xml.=<<XML;
</rdf:RDF>
XML

$atom.=<<XML;
</feed>
XML


		if($rsscode eq '1'){
			#utf8ɃGR[h
			$xml=$jcode->JCodeConvert($ms,$xml,'utf8','sjis');
			$atom=$jcode->JCodeConvert($ms,$atom,'utf8','sjis');
		}
		$ms->getIO->writeFile($index_html_dir.'mysketch.rdf',$xml);
		$ms->getIO->writeFile($index_html_dir.'mysketch_atom.xml',$atom);
		undef $xml;
		undef $atom;
	}
}

1;
