package Msm::XmlNode;

use strict;

sub new{
	my $self=shift;
	my $name=shift;
	my $parent=shift;
	my $attr=shift;
	my $hash={};

	bless $hash,$self;

	$hash->{name}=$name;
	$hash->{child}=[];
	$hash->{childcnt}=0;
	$hash->{parent}=$parent;
	$hash->{attr}=$attr;
	$hash->{value}=undef;
	return $hash;

}

#
#	̃^O̖OԂB
#
sub getNodeName(){
	my $self=shift;
	return $self->{name};
}

sub addValue(){
	my $self=shift;
	my $text=shift;
	$self->{value}.=$self->escape($text);
}

#
#	̃^O<aaa>xxxx</aaa>xxxԂB
#
sub getValue(){
	my $self=shift;
	return $self->unescape($self->{value});
}

#
#	w肳ꂽȎlԂB
#
sub getAttr(){
	my $self=shift;
	my $name=shift;
	return $self->{attr}->{$name};
}

sub getAttrNames(){
	my $self=shift;
	my $name=shift;
	return keys %{$self->{attr}};
}

#
#	̃m[h̐em[hԂB
#
sub getParentNode(){
	my $self=shift;
	return $self->{parent};
}

sub setParentNode(){
	my $self=shift;
	my $node=shift;
	$self->{parent}=$node;
}
sub pushNode(){
	my $self=shift;
	my $node=shift;
	push @{$self->{child}},$node;
	push @{$self->{childnames}->{$node->getNodeName()}},$node;
	$node->setParentNode($self);
}

sub getNextChildNode(){
	my $self=shift;
	my @data=@{$self->{child}};
	if(@data <= $self->{childcnt}){
		return undef;
	}else{
		my $ret=$data[$self->{childcnt}];
		$self->{childcnt}++;
		return $ret;
	}
}

sub getChildNode(){
	my $self=shift;
	my $name=shift;
	if($self->{childnames}->{$name}){
		return wantarray?@{$self->{childnames}->{$name}}:$self->{childnames}->{$name}->[0];
	}else{
		return ();
	}
}

sub getChildNodes(){
	my $self=shift;
	my @data=@{$self->{child}};
	return @data;
}

sub escape{
	my $self=shift;
	my $text=shift;
	if(!defined($text)){
		return $text;
	}

	$text=~s/&/&amp;/g;
	$text=~s/'/&apos;/g;
	$text=~s/"/&quot;/g;
	$text=~s/</&lt;/g;
	$text=~s/>/&gt;/g;
	return $text;
}

sub unescape{
	my $self=shift;
	my $text=shift;
	if(!defined($text)){
		return $text;
	}

	$text=~s/&apos;/'/g;
	$text=~s/&quot;/"/g;
	$text=~s/&lt;/</g;
	$text=~s/&gt;/>/g;
	$text=~s/&amp;/&/g;

	return $text;
}

1;
